﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InstanceTest
{
    class Bus
        : Car
    {
        //プロパティ==========
        public int SalesAmount { get; private set; }        //運賃
        public int PassengerNumber { get; private set; }    //乗客人数

        //コンストラクタ==========
        public Bus()
            : this(100)
        {
        }

        public Bus(double gas)
            : base(gas)
        {
            this.SalesAmount = 0;
            this.PassengerNumber = 0;
        }

        //メソッド==========
        //乗車させるメソッド
        public string RideToBus(int fare){
            //走行中かどうか
            if (this.Speed != 0)
            {
                return "停車してください。";
            }
            //満席かどうか
            if (this.PassengerNumber >= 50)
            {
                return "満席のため、乗車できません。";
            }
            //料金と、乗車人数を加算
            this.SalesAmount += fare;
            this.PassengerNumber++;
            return null;
        }

        //降車させるメソッド
        public string GetOffBus()
        {
            //走行中かどうか
            if (this.Speed != 0)
            {
                return "停車してください。";
            }
            //乗客がいるかどうか
            if (this.PassengerNumber == 0)
            {
                return "乗客はいません。";
            }
            //乗車人数を減算
            this.PassengerNumber--;
            return null;
        }

        //加速させるメソッド(オーバーライド)
        public override void SpeedUp(int sp)
        {
            if ((this.Speed + sp) <= 60)
            {
                base.SpeedUp(sp);
            }
        }
    }
}
